/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*   Description:  a library for finding the maximum clique from a graph     */
/*                                                                           */
/*   Authors: Bharath Pattabiraman and Md. Mostofa Ali Patwary               */
/*            EECS Department, Northwestern University                       */
/*            email: {bpa342,mpatwary}@eecs.northwestern.edu                 */
/*                                                                           */
/*   Copyright, 2012, Northwestern University                                */
/*   See COPYRIGHT notice in top-level directory.                            */
/*                                                                           */
/*   Please cite the following publication if you use this package           */
/*     Bharath Pattabiraman, Mostofa Patwary, Assefaw Gebremedhin, Wei-Keng  */
/*     Liao and Alok Choudhary, Fast Algorithms for the Maximum Clique       */
/*     Problem on Massive Sparse Graphs, In the 10th Workshop on Algorithms  */
/*     and Models for the Web Graph, Cambridge, MA, 2013.                    */
/*                                                                           */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "../src/graphIO.h"
#include<stdlib.h>
using namespace std;

int main(int argc, char *argv[])
{
	string fileNameNoExt = argv[1];	
	string inFileName = fileNameNoExt + ".mtx";
	string outFileName = fileNameNoExt + ".tmp";
	string line,line2, temp;
	int temp1, temp2, temp3;
	ifstream in(inFileName.c_str());
	ofstream out(outFileName.c_str());
	istringstream iin, iin3;
	out << "c File: " << fileNameNoExt << endl;
	int i=0, count=0;
	while(in) 
	{
		getline(in, line);
		if(line=="") 
			break;

		if(line[0] == '%')
			continue;

		if(i==0)
		{
			i++;
			iin.str(line);
			iin>>temp;out<<"p edge "<<temp;
			iin>>temp>>temp>>temp>>temp;out<<" "<<temp<<endl;
			continue;
		}

		line2=line;

		iin3.clear();
		iin3.str(line);
		iin3>>temp1>>temp2>>temp3;
		if(temp1 == temp2)
		{
			count++;
			//cout << "equal " << temp1 << endl;
			continue;
		}

		out<<"e " << line2 <<endl;
	}
	//cout << count << endl;

	in.close();
	out.close();	

	inFileName = fileNameNoExt + ".tmp";
	outFileName = fileNameNoExt + ".gr";
	ifstream in2(inFileName.c_str());
	ofstream out2(outFileName.c_str());
	istringstream iin2;
	while(in2) 
	{
		getline(in2, line);

		if(line[0] == 'p')
		{
			iin2.str(line);
			iin2>>temp;
			out2<<temp<<" ";iin2>>temp;out2<<temp<<" ";
			iin2>>temp;
			out2<< temp; out2<<" ";
			iin2>>temp; out2<< atoi(temp.c_str())-count;out2<<endl;
			continue;
		}

		out2 << line << endl;
	}

	string xyz = "rm " + inFileName;
	system(xyz.c_str());
	in2.close();
	out2.close();	
}
